;******************************************************************************
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
;    I (Simon Wood) can be contacted via email - unilink@mungewell.org
;    or via post - 14 Kirklands Close, Baildon, West Yorkshire, England.
;
;******************************************************************************
;;
;;	TITLE           "GNU-link : CD-Multichanger Emulation"
;;	SUBTITLE        "Released under the GPL license, (c) S Wood, Oct 2001"
;;
;******************************************************************************
; GNUnilink Configuration.
; Uncomment the lines relivent to your board... 
;
; this should be only configuration required.

; Type of PIC (or closest)	;; <PIC_12C509 is Not supported>
;#define		PIC_16F84	;;84A is recommended
;#define		PIC_16F88
;#define		PIC_16F627
;#define		PIC_16F628		;;628A is also available
;#define		PIC_16F648
#define		PIC_12F683


; Speed (or closet)
#define		SPEED_20MHZ	;; Strongly Recomended
;;;#define		SPEED_16MHZ
;;;#define		SPEED_10MHZ
;;;#define		SPEED_8MHZ
;;;#define		SPEED_4MHZ


;;*********************************************************************
;;PIC_16F84A/88/12F683: Serial Input/Output are Not supported
;;           So, please Do NOT select except TRACKNAMES
;;PIC_16F627: Program Size is limited to 1Kword, 
;;           So, please Do NOT select all. 
;;---------------------------------------------------------------------

; Track Names - use tracknames (as well as disknames)
#define		TRACKNAMES

;;---------------------------------------------------------------------
; Serial Output - report the button presses on the head unit to the PC via
; serial port
;#define		SERIAL_OUTPUT

; Serial Input - allow PC to change Disk/Track Names/Numbers and report Track 
; Counter via serial port
;#define		SERIAL_INPUT

; Track mode selection - detects Intro, Repeat and Shuf modes.
;#define		TRACKMODES

; Direct Disk Selection.
;#define		DISKDIRECT

; Long Names - use 16 characters Disk/Track names, only usable if serial 
; input is also selected.
;#define		LONGNAMES

;;--- Second_Anyone		;; June 01 2005 (T)
;;   Sophana (http://sophana.free.fr/) did find out a solution 
;;   that skipping to respond the first "Anyone" intentionally 
;;   is available for accepting some kind of HU's with internal CD.
#define		Second_Anyone

;******************************************************************************
; Real settings for the PIC - if you need to add a new one do it here, 
; otherwise select one from above
;;-------------------------------------------------------------------------
;; PIC_12C509 is Not supported
;;-------------------------------------------------------------------------

		Radix   DEC
		EXPAND
;;----
	IFDEF	PIC_16F84
		Processor       16f84a
		include         "p16f84a.inc"
	__CONFIG _CP_OFF & _PWRTE_ON & _HS_OSC & _WDT_OFF
#define		PIC_16
	ENDIF
;;----
	IFDEF	PIC_16F88
		Processor       16f88
		include         "p16f88.inc"
	__CONFIG _CP_OFF & _PWRTE_ON & _HS_OSC & _WDT_OFF & _LVP_OFF
#define		PIC_16
	ENDIF
;;----
	IFDEF	PIC_16F627
		Processor       16f627
		include         "p16f627.inc"
	__CONFIG _CP_OFF & _PWRTE_ON & _HS_OSC & _WDT_OFF & _LVP_OFF
#define		PIC_16F62x
#define		PIC_16
	ENDIF
;;----
	IFDEF	PIC_16F628
		Processor       16f628
		include         "p16f628.inc"
	__CONFIG _CP_OFF & _PWRTE_ON & _HS_OSC & _WDT_OFF & _LVP_OFF
#define		PIC_16F62x
#define		PIC_16
	ENDIF
;;----
	IFDEF	PIC_16F648
		Processor       16f648a
		include         "p16f648a.inc"
	__CONFIG _CP_OFF & _PWRTE_ON & _HS_OSC & _WDT_OFF & _LVP_OFF
#define		PIC_16F62x
#define		PIC_16
	ENDIF
;;----
	IFDEF	PIC_12F683
		Processor       12f683
		include         "p12f683.inc"
	__CONFIG _FCMEN_OFF & _IESO_OFF & _BOD_ON & _CPD_OFF & _CP_OFF & _MCLRE_OFF & _PWRTE_ON & _WDT_OFF &  _HS_OSC
	ENDIF
;;----

	IFDEF	PIC_16
#define		OUT_PORT	PORTA
#define		OUT_ENA		TRISA
	ENDIF

;;----
	IFDEF	PIC_12F683
#define		OUT_PORT	GPIO
#define		OUT_ENA		TRISIO
#define		CM_CONTL	CMCON0
	ENDIF
;;----

	IFDEF	SERIAL_OUTPUT
	IFNDEF	SERIAL
#define		SERIAL
	ENDIF
	ENDIF

	IFDEF	SERIAL_INPUT
	IFNDEF	SERIAL
#define		SERIAL
	ENDIF
	ENDIF

;******************************************************************************
; A few standard definitions

_ResetVector	set	0x00
_IntVector      set     0x04

TRUE	equ	1
FALSE	equ	0

;******************************************************************************
; Timing Calibration Values - These are non critical in that they don't have 
; to be absolutely correct, but it's nicer to be almost right if you can....

; 100us delay loop is 8 + (n * 7) cycles.

	IFDEF	SPEED_4MHZ
#define		delay100us	13
#define		baud_val	12	; 19231 baud
	ENDIF

	IFDEF	SPEED_8MHZ
#define		delay100us	27
#define		baud_val	25	; 19231 baud
	ENDIF

	IFDEF	SPEED_10MHZ
#define		delay100us	34
#define		baud_val	32	; 18939 baud
	ENDIF

	IFDEF	SPEED_16MHZ
#define		delay100us	56
#define		baud_val	51	; 19231 baud
	ENDIF

	IFDEF	SPEED_20MHZ
#define		delay100us	70
#define		baud_val	64	; 19231 baud
;;#define		baud_val	10	; 113363 baud(115K)
	ENDIF

;******************************************************************************
;                               Setup Register Locations

DataVal		set		0x20
Count		set		0x21
Count2		set		0x22
Checksum	set		0x23

Rad		set		0x24
Tad		set		0x25
Cmd1		set		0x26
Cmd2		set		0x27
Parity1		set		0x28
Data11		set		0x29
Data12		set		0x2A
Data13		set		0x2B
Data14		set		0x2C
Data21		set		0x2D
Data22		set		0x2E
Data23		set		0x2F
Data24		set		0x30
Data25		set		0x31
Parity2		set		0x32
EndByte		set		0x33

MyId		set		0x34
Display		set		0x35
MyBit		set		0x36
MyGroup		set		0x37

Res_ISB		set		0x38
SwSourceDone	set		0x39
PauseDone	set		0x3a
Appoint_Now	set		0x3b
MyIdCont_Flag	set		0x3c
Count3		set		0x3d
CnfChk_Count	set		0x3e
NeedToTalk	set		0x3f

Time1		set		0x40
Time0		set		0x41
DiskNum		set		0x42
TrackNum	set		0x43
DispCtrl	set		0x44

FirstAnyone	set		0x47


	IFDEF	PIC_16F62x
;;-----------------------------------
Disk0		set		0x48
Disk1		set		0x49
Disk2		set		0x4a
Disk3		set		0x4b
Disk4		set		0x4c
Disk5		set		0x4d
Disk6		set		0x4e
Disk7		set		0x4f

Track0		set		0x58
Track1		set		0x59
Track2		set		0x5a
Track3		set		0x5b
Track4		set		0x5c
Track5		set		0x5d
Track6		set		0x5e
Track7		set		0x5f

	IFDEF	SERIAL
command_offset	set		0x71	; used to hold the current output text
status_store	set		0x72	; stores STATUS reg during interrupt
w_store		set		0x73	; stores w reg during interrupt
SerialReplace	set		0x74	; temp storage for replacement character

	IFDEF	SERIAL_INPUT
RXChar		set		0x75
RXState		set		0x76
RXPointer	set		0x77

	IFDEF	LONGNAMES
Disk8		set		0x50
Disk9		set		0x51
DiskA		set		0x52
DiskB		set		0x53
DiskC		set		0x54
DiskD		set		0x55
DiskE		set		0x56
DiskF		set		0x57

Track8		set		0x60
Track9		set		0x61
TrackA		set		0x62
TrackB		set		0x63
TrackC		set		0x64
TrackD		set		0x65
TrackE		set		0x66
TrackF		set		0x67
	ENDIF	;;<LONGNAMES>
	ENDIF	;;<SERIAL_INPUT>
	ENDIF	;;<SERIAL>
;;-----------------------------------
	ENDIF	;;<PIC_16F62x>

;******************************************************************************
; Port definitions, which signal is where on the OUT_PORT

	IFDEF	PIC_16
#define		DataBit		0
#define 	ClockBit	1
#define		BusOnBit	2
#define 	CdNotMdBit	3
	ENDIF

	IFDEF	PIC_12F683
#define		BusOnBit	1
#define		DataBit		2	;; (ST input)
#define 	ClockBit	3
;;#define 	LEDBit		0
#define 	CdNotMdBit	0
	ENDIF

;******************************************************************************
; Default definations for responses, these may need to be changed for you
; particular HEADUNIT

Anyone_0	set		0x8C
Anyone_1	set		0x10
Anyone_2	set		0xFF
Anyone_3	set		0xFF
Anyone_4	set		0xFF
Anyone_5	set		0xFF

Appoint_0	set		0x8C
Appoint_1	set		0x10
Appoint_2	set		0x05
Appoint_3	set		0xA8
Appoint_4	set		0x00
Appoint_5	set		0x00

;******************************************************************************
; Default definations for names etc.

	IFDEF	TRACKNAMES
Track0_def	set		'G'		; Track Name
Track1_def	set		'P'
Track2_def	set		'L'
Track3_def	set		'-'
Track4_def	set		'2'
Track5_def	set		'0'
Track6_def	set		'0'
Track7_def	set		'3'
	ENDIF

Disk0_def	set		'<'		; Disk Name
Disk1_def	set		'A'
Disk2_def	set		'U'
Disk3_def	set		'X'
Disk4_def	set		'-'
Disk5_def	set		'I'
Disk6_def	set		'N'
Disk7_def	set		'>'

;******************************************************************************
; Start of code space

	ORG     _ResetVector
	
	goto	SystemSetup

;******************************************************************************

	include "interrupt.asm"
	include "functions.asm"
	include "setup.asm"
	include "receive.asm"
	include "parse.asm"
	include	"respond.asm"
	include "display.asm"

;******************************************************************************

	END










